
player = { x = 100, y = 100, speed = 150, img = nil }

love.graphics.setBackgroundColor(0x6b,0x92,0xb9)
-- love.graphics.setBackgroundColor(0xee,0xe9,0xe9)
local particles = {}
local MAX_PARTICLES = 25
local MP = MAX_PARTICLES
local W = 800
local H = 600

function sim_load()
	for i=1,MAX_PARTICLES do
		particles[i] = {}
		local p = particles[i]
		p.x = math.random() * W
		p.y = math.random() * H
		p.r = math.random()*4 + 1
		p.d = math.random()* MP
	end
end

function love.load(arg)
  if arg[#arg] == "-debug" then require("mobdebug").start() end
  player.img = love.graphics.newImage("stone_soup_icon-32x32.png")
  sim_load()
end

local angle = 0.0 -- used in update
function love.update(dt)
  if love.keyboard.isDown("escape") then
    love.event.push("quit")
  end
  if love.keyboard.isDown("left","a") then
    player.x = player.x - (player.speed * dt)
    if player.x<0 then
      player.x=0
    end
  elseif love.keyboard.isDown("right","d") then
    player.x = player.x + (player.speed * dt)
    if player.x>love.graphics.getWidth()-player.img:getWidth() then
      player.x = love.graphics.getWidth()-player.img:getWidth()
    end
  elseif love.keyboard.isDown("up","w") then
    player.y = player.y - (player.speed * dt)
    if player.y<0 then
      player.y=0
    end
  elseif love.keyboard.isDown("down","s") then
    player.y = player.y + (player.speed * dt)
    if player.y>love.graphics.getHeight()-player.img:getHeight() then
      player.y = love.graphics.getHeight()-player.img:getHeight()
    end
  end
  angle = angle + 0.01
	for i=1,MAX_PARTICLES do
		local p = particles[i]
		p.y = p.y + math.cos(angle + p.d) + 1 + p.r/2
		p.x = p.x + math.sin(angle) * 2

		if (p.x>W+5) or (p.x<-5) or (p.y>H) then
			if i % 3 > 0 then -- 66.67 % of flakes
				p.x = math.random()*W
				p.y = -10
			else
				if math.sin(angle) > 0 then
					p.x = -5
					p.y = math.random()*H
				else
					p.x = W + 5
					p.y = math.random()*H
				end
			end
		end
  end
end

function love.draw(dt)
	for i=1,MAX_PARTICLES do
		local p = particles[i]
		love.graphics.arc("fill", p.x,p.y,p.r,0,3.1415*2,10)
  end  
  love.graphics.draw(player.img, player.x, player.y)
end